package javathreadsprezi;

import java.util.Queue;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.atomic.AtomicInteger;
import sun.misc.JavaxSecurityAuthKerberosAccess;

class JavaThreadsDemo8 implements JavaThreadsDemoable {

    private Queue<String> strings;
    private final int limit = 10000;

    @Override
    public void doDemo() {
        strings = new ArrayBlockingQueue<>(limit);
        new Thread(new Adder()).start();
        new Thread(new Printer()).start();
        new Thread(new Remover()).start();
        new Thread(new Adder()).start();
        new Thread(new Printer()).start();
        new Thread(new Remover()).start();
        new Thread(new Adder()).start();
        new Thread(new Printer()).start();
        new Thread(new Remover()).start();
        new Thread(new Adder()).start();
        new Thread(new Printer()).start();
        new Thread(new Remover()).start();
        new Thread(new Adder()).start();
        new Thread(new Printer()).start();
        new Thread(new Remover()).start();
        try {
            Thread.sleep(2 * 1000);
        } catch (InterruptedException ex) {
        }
        System.exit(0);
    }

    private class Adder implements Runnable {

        @Override
        public void run() {
            while (true) {
                synchronized (strings) {
                    if (strings.size() < limit) {
                        strings.add("dsgr");
                    }
                }
                AtomicInteger atomicInteger = new java.util.concurrent.atomic.AtomicInteger();
                
            }
        }
    }

    private class Remover implements Runnable {

        @Override
        public void run() {
            while (true) {
                strings.poll();
            }
        }
    }

    private class Printer implements Runnable {

        @Override
        public void run() {
            while (true) {
                System.out.println(strings);
            }
        }
    }
}
