package javathreadsprezi;

import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFrame;
import javax.swing.SwingWorker;
import javax.swing.Timer;

class JavaThreadsDemo6 implements JavaThreadsDemoable {

    @Override
    public void doDemo() {
        javax.swing.Timer timer = new Timer(100, new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                System.out.println(Thread.currentThread().getName());
                JFrame frame = new MyPopupFrame();
                frame.setVisible(true);
            }
        });
        timer.start();
        try {
            Thread.sleep(2000);
        } catch (InterruptedException ex) {
        }
        timer.stop();
    }

    private class MyPopupFrame extends JFrame {

        public MyPopupFrame() {
            setTitle("Frame");
            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            setSize(new Dimension(150, 30));
            setLocation((int) (Math.random() * 800), (int) (Math.random() * 600));
        }
    }
}
